import java.util.*;
import java.io.*;

import java.math.BigInteger;

public class Encode {

  final int LIMIT = 1024;

  BigInteger pow[];
  BigInteger three = new BigInteger("3");

  void init() {
    pow = new BigInteger[LIMIT];
    pow[0] = BigInteger.ONE;
    for(int i=1; i<LIMIT; ++i) {
      pow[i] = pow[i-1].multiply(three);
    }
  }

  String toTern(BigInteger n, int d) {
    String ret = "";
    for(int i=0; i<d; ++i) {
      ret = n.mod(three) + ret;
      n = n.divide(three);
    }
    return ret;
  }

  String toInteger(BigInteger n) {
    for(int i=0; i<LIMIT; ++i) {
      if( n.compareTo(pow[i]) < 0 ) {
        if( i == 0 ) { return "0"; }
        if( i == 1 ) { return "1" + toTern(n, i); }
        return "22" + toInteger(i - 2) + toTern(n, i);
      }
      n = n.subtract(pow[i]);
    }
    throw new Error();
  }

  String toInteger(int n) {
    return toInteger(new BigInteger("" + n));
  }

  String toList(int m) {
    if( m < 2 ) { return "" + m; }
    return "22" + toInteger(m - 2);
  }

  public static void main(String args[]) {
    Encode enc = new Encode();
    enc.init();
    enc.exec();
  }

  void exec() {
    Scanner cin = new Scanner(System.in);
    while( cin.hasNextInt() ) {
      int m = cin.nextInt();
      String ret = "";
      ret += toList(m);
      for(int i=0; i<m; ++i) {
        ret += toList(1);
        ret += toList(1);
        int b = cin.nextInt();
        int p = cin.nextInt();
        ret += toInteger(power(b, p));
      }
      System.out.print(ret);
    }
  }

  BigInteger power(int b, int n) {
    BigInteger base = new BigInteger("" + b);
    BigInteger ret = BigInteger.ONE;
    for(int i=0; i<n; ++i) {
      ret = ret.multiply(base);
    }
    return ret;
  }

}
