import java.util.*;
import java.io.*;

public class Matrix {

  public static void main(String args[]) {
    boolean output = false;
    if( args.length >= 1 ) { output = args[0].equals("output"); }
    Matrix m = new Matrix();
    m.exec(output);
  }

  String toListSize(int n) {
    if( n == 0 ) { return "0"; }
    if( n == 1 ) { return "1"; }
    return "22" + toInteger(n - 2);
  }

  String toTern(int n, int d) {
    String ret = "";
    for(int i=0; i<d; ++i) {
      ret = (n % 3) + ret;
      n /= 3;
    }
    return ret;
  }

  String toInteger(int n) {
    if( n == 0 ) { return "0"; }
    if( n <= 3 ) { return "1" + (n - 1); }
    if( n <= 12 ) { return "220" + toTern(n - 4, 2); }
    if( n <= 39 ) { return "2210" + toTern(n - 13, 3); }
    if( n <= 120 ) { return "2211" + toTern(n - 40, 4); }
    if( n <= 363 ) { return "2212" + toTern(n - 121, 5); }
    return "";
  }

  String encode(int arrs[][][], int m, int n) {
    String ret = "";
    ret += toListSize(m);
    for(int i=0; i<m; ++i) {
      ret += toListSize(n);
      for(int j=0; j<n; ++j) {
        ret += toListSize(n);
        for(int k=0; k<n; ++k) {
          ret += toInteger(arrs[i][j][k]);
        }
      }
    }
    return ret;
  }

  void exec(boolean output) {

    // scan;
    Scanner cin = new Scanner(System.in);
    int n = cin.nextInt();
    int m = cin.nextInt();
    int arrs[][][] = new int[m][n][n];
    for(int i=0; i<m; ++i) {
      for(int j=0; j<n; ++j) {
        for(int k=0; k<n; ++k) {
          arrs[i][j][k] = cin.nextInt();
        }
      }
    }
    int base[][] = new int[n][n];
    for(int i=0; i<n; ++i) { base[i][i] = 1; }

    System.err.println(encode(arrs, m, n));
    if( output ) {
      try {
        Process p = Runtime.getRuntime().exec("./fuel " + encode(arrs, m, n));
        BufferedReader br = new BufferedReader(new InputStreamReader(p.getInputStream()));
        String s;
        while( (s = br.readLine()) != null ) { System.out.println(s); }
      }
      catch(Throwable t) { }
    }

    // eval; a - b;
    while( cin.hasNextInt() ) {
      int a[][] = base;
      int b[][] = base;
      int k;
      k = cin.nextInt();
      for(int i=0; i<k; ++i) {
        a = mult(a, arrs[cin.nextInt()], n);
      }
      // emit(a, n);
      k = cin.nextInt();
      for(int i=0; i<k; ++i) {
        b = mult(b, arrs[cin.nextInt()], n);
      }
      // emit(b, n);
      emit(sub(a, b, n), n);
    }

  }

  int[][] mult(int a[][], int b[][], int n) {
    int c[][] = new int[n][n];
    for(int i=0; i<n; ++i) {
      for(int j=0; j<n; ++j) {
        for(int k=0; k<n; ++k) {
          c[i][j] += a[i][k] * b[k][j];
        }
      }
    }
    return c;
  }

  int[][] sub(int a[][], int b[][], int n) {
    int c[][] = new int[n][n];
    for(int i=0; i<n; ++i) {
      for(int j=0; j<n; ++j) {
        c[i][j] = a[i][j] - b[i][j];
      }
    }
    return c;
  }

  void emit(int a[][], int n) {
    for(int i=0; i<n; ++i) {
      for(int j=0; j<n; ++j) {
        System.err.print(a[i][j] + " ");
      }
      System.err.println();
    }
    System.err.println();
  }

}
