#!/usr/bin/ruby 

circuit = <<-EOS
0 1R 1L
1 2L 2R
2 3L 3R
3 4R 4L
4 5L 5R
5 0R X
EOS

$orders = [];
$names = {}; # name to id
$nodes = {}; # name to {IL, IR, OL, OR}

cnt = 0;

circuit.each_line do |line|
  if line =~ /(\w+)\s+(\w+)\s+(\w+)/ then
    $names[$1] = cnt;
    $orders.push($1);
    if $nodes[$1] then raise($1 + ": the same name") end;
    $nodes[$1] = {};
  elsif line =~ /$\s*^/
    next
  else
    raise "error!"
  end
  cnt += 1;
end

circuit.each_line do |line|
  if line =~ /(\w+)\s+(\w+)\s+(\w+)/ then
    name = $1;
    $nodes[name][:OL] = $2;
    $nodes[name][:OR] = $3;

    if $2 != "X" then
      lname = $2[0..-2];
      if $2[-1..-1] == "L" then
        $nodes[lname][:IL] = name + "L";
      elsif $2[-1..-1] == "R" then
        $nodes[lname][:IR] = name + "L";
      else
        raise "error"
      end
    end

    if $3 != "X" then
      lname = $3[0..-2];
      if $3[-1..-1] == "L" then
        $nodes[lname][:IL] = name + "R";
      elsif $3[-1..-1] == "R" then
        $nodes[lname][:IR] = name + "R";
      else
        raise "error"
      end
    end

  elsif line =~ /^\s*$/ then
    next
  else
    raise "error!"
  end
end

# p $names;
# p $nodes;

# ----------------------------------------------------------------------

def convert(str)
  if str == nil then return "X"; end;
  $names[str[0..-2]].to_s + str[-1..-1];
end

input = nil;
output = nil;
i = 0;
$nodes.each do |k, node|
  input = k + "L" if convert(node[:IL]) == "X";
  input = k + "R" if convert(node[:IR]) == "X";
  output = k + "L" if convert(node[:OR]) == "X";
  output = k + "R" if convert(node[:OR]) == "X";
end

print(convert(input)); puts ":";
$orders.each do |name|
  k = name;
  node = $nodes[name];

  input = k + "L" if convert(node[:IL]) == "X";
  print(convert(node[:IL]));
  input = k + "R" if convert(node[:IR]) == "X";
  print(convert(node[:IR]));

  print("0#");
  output = k + "L" if convert(node[:OL]) == "X";
  print(convert(node[:OL]));
  output = k + "R" if convert(node[:OR]) == "X";
  print(convert(node[:OR]));

  i += 1;
  puts(i != cnt ? "," : ":");
end
puts(convert(output))



