solvedfp = open("SolveLog.txt","r")
solved = Hash.new
solvedfp.each do |ln|
	id,x,ans = ln.split(" ")
	solved[id.to_i] = id.to_i
end
solvedfp.close()



log = open("_solved.txt","w")
lines = readlines
lines.each do |ln|
	id,cham,tank,carspec = ln.split(",")
	carspec = carspec[1..-1]

	if tank.to_i<=1 || solved.key?(id.to_i) || tank.to_i!=4
		next
	end

	# retrieve car spec
	fp = open("_car.txt", "w")
	fp << carspec
	fp.close

	puts "::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
	puts ":: Trying car #{id}: (#{cham} chambers, #{tank} tanks)..."
	puts "::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"

	# run auto solver
	if !system("ocaml tauto.ml < _car.txt > _fuel.txt")
		puts "solver failed #{id}"
		next
	end

	log.puts "#{id} : #{fue=open('_fuel.txt');str=fue.gets(nil);fue.close;str}"
	log.flush

	# convert to circuit
	puts ":: Running Fuel to Circuit encoder (#{id}) ..."
	if !system("fuel < _fuel.txt > _circ.txt")
		puts "fuel encoder failed : #{id}"
		exit
	end

	# submit!
	puts ":: Submit!"
	if !system("ruby submitfuel.rb #{id} < _circ.txt")
		puts "submit failed : #{id}"
		exit
	end
end
